# Generated by Django 4.2.3 on 2023-07-09 19:07

import uuid

import django.core.validators
import django.db.models.deletion
import django.utils.timezone
import model_utils.fields
from django.db import migrations, models

import django_webhook.validators


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Webhook",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created",
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="modified",
                    ),
                ),
                ("url", models.URLField()),
                ("active", models.BooleanField(default=True)),
                ("uuid", models.UUIDField(default=uuid.uuid4, editable=False)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="WebhookTopic",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        max_length=250,
                        unique=True,
                        validators=[
                            django.core.validators.RegexValidator(
                                "\\w+\\.\\w+\\/[create|update|delete]",
                                message="Topic must match: \\w+\\.\\w+\\/[create|update|delete]",
                            ),
                            django_webhook.validators.validate_topic_model,
                        ],
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="WebhookSecret",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "token",
                    models.CharField(
                        max_length=100,
                        validators=[django.core.validators.MinLengthValidator(12)],
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now, editable=False
                    ),
                ),
                (
                    "webhook",
                    models.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="secrets",
                        related_query_name="secret",
                        to="django_webhook.webhook",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="webhook",
            name="topics",
            field=models.ManyToManyField(
                related_name="webhooks",
                related_query_name="webhook",
                to="django_webhook.webhooktopic",
            ),
        ),
    ]
