# Generated by Django 4.2.3 on 2023-07-22 11:42

import django.core.serializers.json
import django.db.models.deletion
import django.utils.timezone
import model_utils.fields
from django.db import migrations, models


class Migration(migrations.Migration):
    dependencies = [
        ("django_webhook", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="WebhookEvent",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "object",
                    models.JSONField(
                        editable=False,
                        encoder=django.core.serializers.json.DjangoJSONEncoder,
                        max_length=1000,
                    ),
                ),
                (
                    "object_type",
                    models.CharField(editable=False, max_length=50, null=True),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("PENDING", "PENDING"),
                            ("FAILURE", "FAILURE"),
                            ("SUCCESS", "SUCCESS"),
                        ],
                        default="PENDING",
                        editable=False,
                        max_length=40,
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now, editable=False
                    ),
                ),
                ("url", models.URLField(editable=False)),
                ("topic", models.CharField(editable=False, max_length=250, null=True)),
                (
                    "webhook",
                    models.ForeignKey(
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="events",
                        related_query_name="event",
                        to="django_webhook.webhook",
                    ),
                ),
            ],
        ),
    ]
